searchData={"items":[{"type":"module","title":"PushEx","doc":"PushEx context exposes public API functions.","ref":"PushEx.html"},{"type":"function","title":"PushEx.child_spec/1","doc":"Returns a child_spec that can be used to start the PushEx web endpoint.","ref":"PushEx.html#child_spec/1"},{"type":"function","title":"PushEx.connected_channel_count/0","doc":"Returns the number of channels connected to this node.","ref":"PushEx.html#connected_channel_count/0"},{"type":"function","title":"PushEx.connected_channel_pids/0","doc":"Returns the pids of connected Channel processes.","ref":"PushEx.html#connected_channel_pids/0"},{"type":"function","title":"PushEx.connected_socket_count/0","doc":"Returns the number of sockets (transports) connected to this node.","ref":"PushEx.html#connected_socket_count/0"},{"type":"function","title":"PushEx.connected_transport_pids/0","doc":"Returns the pids of connected transport processes (Socket processes).","ref":"PushEx.html#connected_transport_pids/0"},{"type":"function","title":"PushEx.push/1","doc":"Triggers a Push to be instrumented/enqueued into the system.","ref":"PushEx.html#push/1"},{"type":"module","title":"PushEx.Supervisor","doc":"","ref":"PushEx.Supervisor.html"},{"type":"function","title":"PushEx.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"PushEx.Supervisor.html#child_spec/1"},{"type":"function","title":"PushEx.Supervisor.init/1","doc":"","ref":"PushEx.Supervisor.html#init/1"},{"type":"function","title":"PushEx.Supervisor.pubsub_config/0","doc":"","ref":"PushEx.Supervisor.html#pubsub_config/0"},{"type":"function","title":"PushEx.Supervisor.start_link/1","doc":"","ref":"PushEx.Supervisor.html#start_link/1"},{"type":"module","title":"PushExWeb.PushTracker","doc":"","ref":"PushExWeb.PushTracker.html"},{"type":"function","title":"PushExWeb.PushTracker.child_spec/1","doc":"","ref":"PushExWeb.PushTracker.html#child_spec/1"},{"type":"function","title":"PushExWeb.PushTracker.handle_diff/2","doc":"","ref":"PushExWeb.PushTracker.html#handle_diff/2"},{"type":"function","title":"PushExWeb.PushTracker.init/1","doc":"","ref":"PushExWeb.PushTracker.html#init/1"},{"type":"function","title":"PushExWeb.PushTracker.listeners?/2","doc":"","ref":"PushExWeb.PushTracker.html#listeners?/2"},{"type":"function","title":"PushExWeb.PushTracker.start_link/1","doc":"","ref":"PushExWeb.PushTracker.html#start_link/1"},{"type":"function","title":"PushExWeb.PushTracker.track/1","doc":"","ref":"PushExWeb.PushTracker.html#track/1"},{"type":"behaviour","title":"PushEx.Behaviour.Controller","doc":"Implementable functions that are used by the API controller. It is crucial to ensure that all API calls are secured behind proper auth.","ref":"PushEx.Behaviour.Controller.html"},{"type":"callback","title":"PushEx.Behaviour.Controller.auth/2","doc":"Accepts a Plug.Conn and params map to determine if the API is allowed to be accessed. It is possible to modify\nthe response Plug.Conn completely, or return simple `:ok | :error` atoms.","ref":"PushEx.Behaviour.Controller.html#c:auth/2"},{"type":"behaviour","title":"PushEx.Behaviour.PushInstrumentation","doc":"Implementable hook points for push lifecycle instrumentation. Callbacks are required but do not need to do anything.","ref":"PushEx.Behaviour.PushInstrumentation.html"},{"type":"callback","title":"PushEx.Behaviour.PushInstrumentation.api_processed/1","doc":"Called immediately before an API response is delivered.","ref":"PushEx.Behaviour.PushInstrumentation.html#c:api_processed/1"},{"type":"callback","title":"PushEx.Behaviour.PushInstrumentation.api_requested/1","doc":"Called when an API request is started.","ref":"PushEx.Behaviour.PushInstrumentation.html#c:api_requested/1"},{"type":"callback","title":"PushEx.Behaviour.PushInstrumentation.delivered/2","doc":"Called when a push is delivered to a Channel. This can occur more, less, or the same number of times as a push\nbeing requested.","ref":"PushEx.Behaviour.PushInstrumentation.html#c:delivered/2"},{"type":"callback","title":"PushEx.Behaviour.PushInstrumentation.requested/2","doc":"Called when a push is requested to be sent. By default this happens in the API controller.","ref":"PushEx.Behaviour.PushInstrumentation.html#c:requested/2"},{"type":"behaviour","title":"PushEx.Behaviour.Socket","doc":"Implementable functions that are used in the flow of socket/channel creation. It is crucial to implement secure connect/join functions\nfor all applications.","ref":"PushEx.Behaviour.Socket.html"},{"type":"callback","title":"PushEx.Behaviour.Socket.channel_join/3","doc":"See `c:Phoenix.Channel.join/3`","ref":"PushEx.Behaviour.Socket.html#c:channel_join/3"},{"type":"callback","title":"PushEx.Behaviour.Socket.presence_identifier/1","doc":"See `c:Phoenix.Presence.track/4` `key`","ref":"PushEx.Behaviour.Socket.html#c:presence_identifier/1"},{"type":"callback","title":"PushEx.Behaviour.Socket.socket_connect/2","doc":"See `c:Phoenix.Socket.connect/3`","ref":"PushEx.Behaviour.Socket.html#c:socket_connect/2"},{"type":"callback","title":"PushEx.Behaviour.Socket.socket_id/1","doc":"See `c:Phoenix.Socket.id/1`","ref":"PushEx.Behaviour.Socket.html#c:socket_id/1"},{"type":"module","title":"PushEx.Instrumentation.Push.Context","doc":"Generic information about the instrumentation event.","ref":"PushEx.Instrumentation.Push.Context.html"},{"type":"type","title":"PushEx.Instrumentation.Push.Context.t/0","doc":"","ref":"PushEx.Instrumentation.Push.Context.html#t:t/0"},{"type":"module","title":"PushEx.Push","doc":"Push data that should be delivered to a given channel/event.","ref":"PushEx.Push.html"},{"type":"type","title":"PushEx.Push.t/0","doc":"","ref":"PushEx.Push.html#t:t/0"},{"type":"extras","title":"PushEx","doc":"# PushEx\n\n[![Hex.pm](https://img.shields.io/hexpm/v/push_ex.svg)](https://hex.pm/packages/push_ex)\n[![Hex.pm](https://img.shields.io/hexpm/dt/push_ex.svg)](https://hex.pm/packages/push_ex)\n[![Hex.pm](https://img.shields.io/hexpm/l/push_ex.svg)](https://github.com/pushex-project/pushex/blob/master/LICENSE)\n[![Build Status](https://travis-ci.org/pushex-project/pushex.svg?branch=master)](https://travis-ci.org/pushex-project/pushex)\n\nPushEx is an implementation of Phoenix Channels which handles best practices of running WebSockets for you, but\nallows your business logic to be specified through simple behaviour modules.\n\nPushEx is in use at SalesLoft, powering a large amount of pushes per day. It has been stable since early 2019, with no\noperational incidents.","ref":"readme.html"},{"type":"extras","title":"Key Links - PushEx","doc":"- [Hexdocs.pm](https://hexdocs.pm/push_ex)\n- [Pushex.js Github](https://github.com/pushex-project/pushex.js)\n- [Pushex.js npm](https://www.npmjs.com/package/pushex.js)","ref":"readme.html#key-links"},{"type":"extras","title":"Features - PushEx","doc":"- Push socket/channel implementation\n- Push API implementation\n- Customizable hook points to allow authentication and instrumentation\n- Designed for performance with a large number of connections and messages\n- JS client built on top of Phoenix.js","ref":"readme.html#features"},{"type":"extras","title":"Compared to Phoenix - PushEx","doc":"PushEx is built on top of Phoenix Channel and Presence. If you look at the source code, it is actually a very thin layer on top of this core functionality; most of the code is around ensuring a scalable system which is set up for success without knowing how Phoenix works.\n\nPushEx is better compared to a pre-built microservice that is ready to go. By implementing a few application specific functions, you can bring a fully baked push WebSocket server to your application. You will also benefit from community upgrades regarding functionality and performance; this is true both for Phoenix changes and PushEx changes. You do *not* need to know how Phoenix works in order to build a scalable system.","ref":"readme.html#compared-to-phoenix"},{"type":"extras","title":"Get Started - PushEx","doc":"The best way to get started is by following the [Standalone Installation Guide](https://hexdocs.pm/push_ex/standalone.html).\n\nIt is possible to integrate PushEx with an existing Phoenix application, although this is not recommended for applications which are deployed often. The installation guide for this case is slated for the future. Please open an issue if you'd like it for your use case.\n\nThe [PushEx docs](https://hexdocs.pm/push_ex) contain many guides such as authentication, deployment, instrumentation, PushEx.js, PubSub, API usage. Please see this guide for up to date information. You can also access these guides in the repo folder `guides`.","ref":"readme.html#get-started"},{"type":"extras","title":"Current Version - PushEx","doc":"Add the following to your mix.exs `deps` in order to get the latest version of PushEx:\n\n```\n  {:push_ex, \"~> 2.1.0\"},\n```","ref":"readme.html#current-version"},{"type":"extras","title":"Examples - PushEx","doc":"Examples are located in the examples directory. The test_frontend_socket example is the most complete and simple example.","ref":"readme.html#examples"},{"type":"extras","title":"Company Sponsor - PushEx","doc":"A big thanks to [SalesLoft](https://salesloft.com) for helping with the development and open-sourcing of PushEx. Their support of my professional and personal time into this project (it was formed in an Innovation Week) is the type of thing that makes them [Atlanta's best place to work](https://www.ajc.com/business/growing-software-firm-built-core-values/Xjnm3EnCNe4Cub0JNbPOZL/).","ref":"readme.html#company-sponsor"},{"type":"extras","title":"Real-Time Phoenix Book - PushEx","doc":"Consider checking out my book [Real-Time Phoenix](https://pragprog.com/book/sbsockets/real-time-phoenix) if you are interested\nin writing real-time systems in Elixir.","ref":"readme.html#real-time-phoenix-book"},{"type":"extras","title":"Installation - Standalone","doc":"# Installation - Standalone\n\nPushEx is an implementation of Phoenix websockets/channels which handles best practices of running websockets for you, but allows your business logic to be specified through simple behaviour modules.\n\nThis guide will go through the steps necessary to create a standalone deployment of PushEx tailored to your business needs, from start to finish.","ref":"standalone.html"},{"type":"extras","title":"Why Standalone? - Installation - Standalone","doc":"A standalone installation is preferred and is how I would run any serious push service. This is because push services change very infrequently and so should not be deployed often. Each deploy causes reconnection of current sockets and a slight miss of messages in that time. Having a standalone service also allows for easier scaling, as new nodes can be added to the cluster quickly to meet your push capacity needs.","ref":"standalone.html#why-standalone"},{"type":"extras","title":"Pre-installation - Installation - Standalone","doc":"Ensure that your Elixir is version >= 1.12 and that your Erlang is >= OTP24:\n\n```\nelixir --version\nErlang/OTP 24 [erts-12.0.3] [source] [64-bit] [smp:8:8] [ds:8:8:10] [async-threads:1]\nElixir 1.12.3 (compiled with Erlang/OTP 24)\n```\n\nYou can attempt installation without this, check the `.github/workflows/elixir.yml` file\nto see the test matrix that's supported. Generally, we only support the most recent versions\ndepending on the needs of Phoenix / Elixir.","ref":"standalone.html#pre-installation"},{"type":"extras","title":"Instructions - Installation - Standalone","doc":"1. Create a new supervised mix application\n\n```\nmix new demo_app --sup && cd demo_app\n```\n\n2. Install the latest push_ex release (see main README) and `mix deps.get`\n\n```\n  # mix.exs\n\n  defp deps do\n    [\n      {:push_ex, \"FROM README\"}\n    ]\n  end\n```\n\n3. Add `PushEx` to your Application children:\n\n```\n # my_app/application.ex\n\n ...\n children = [\n   ...\n  PushEx,\n ]\n ...\n```\n\nThis step helps ensure that you can start PushEx in the correct location. For instance, you may\nwant to start it after Statix boots if you are using StatsD instrumentation.\n\n4. Setup required options in config.exs\n\n```\nuse Mix.Config\n\n# Configures the endpoint, these are Phoenix Endpoint options\nconfig :push_ex, PushExWeb.Endpoint,\n  url: [host: \"localhost\"],\n  render_errors: [view: PushExWeb.ErrorView, accepts: ~w(json)],\n  pubsub_server: PushEx.PubSub,\n  http: [port: 4004],\n  check_origin: false,\n  watchers: [],\n  server: true\n\n# Set the pool size to the number of cores of your server\nconfig :push_ex, PushEx.PubSub,\n  adapter: Phoenix.PubSub.PG2,\n  pool_size: 4\n\n# Configures Elixir's Logger (vary based on deployment environment)\nconfig :logger, :console,\n  level: :error,\n  format: \"$time $metadata[$level] $message\\n\",\n  metadata: [:request_id]\n\n# Use Jason for JSON parsing in Phoenix\nconfig :phoenix, :json_library, Jason\n\nconfig :push_ex, PushEx.Instrumentation, push_listeners: [DemoApp.PushInstrumenter]\n\nconfig :push_ex, PushExWeb.PushSocket, socket_impl: DemoApp.Socket\n\nconfig :push_ex, PushExWeb.PushController, controller_impl: DemoApp.Controller\n```\n\n5. Implement Socket, Controller, Instrumentation modules\n\n```\n# demo_app/socket.ex\n\ndefmodule DemoApp.Socket do\n  @behaviour PushEx.Behaviour.Socket\n\n  def socket_connect(_params, socket) do\n    {:ok, socket}\n  end\n\n  def socket_id(_socket) do\n    \"id\"\n  end\n\n  def presence_identifier(socket) do\n    socket_id(socket)\n  end\n\n  def channel_join(_channel, _params, socket) do\n    {:ok, socket}\n  end\nend\n```\n\n```\n# demo_app/controller.ex\n\ndefmodule DemoApp.Controller do\n  @behaviour PushEx.Behaviour.Controller\n\n  def auth(_conn, _params) do\n    :ok\n  end\nend\n```\n\n```\n# demo_app/push_instrumenter.ex\n\ndefmodule DemoApp.PushInstrumenter do\n  @behaviour PushEx.Behaviour.PushInstrumentation\n\n  require Logger\n\n  def delivered(%PushEx.Push{} = push, ctx) do\n    Logger.debug(\"#{__MODULE__} delivered #{inspect(push)} #{inspect(ctx)}\")\n  end\n\n  def requested(%PushEx.Push{} = push, ctx) do\n    Logger.debug(\"#{__MODULE__} requested #{inspect(push)} #{inspect(ctx)}\")\n  end\n\n  def api_requested(ctx) do\n    Logger.debug(\"#{__MODULE__} controller requested #{inspect(ctx)}\")\n  end\n\n  def api_processed(ctx) do\n    Logger.debug(\"#{__MODULE__} controller processed #{inspect(ctx)}\")\n  end\nend\n```\n\n6. Implement your custom application logic\n\nIt's crucial that your application ships with proper authentication logic, or anyone could access sensitive information over your sockets. This may be fine if you're pushing data down to all users of a marketing site, but would be unacceptable in any environment with separate users.\n\nPushEx behaviours are all documented with their types. It is possible to fully customize the flow of the system using these behaviours. An example of this is accepting a JWT on `socket_connect` + `channel_join` and enforcing that the JWT is valid and matches private channel claims.\n\nInstrumentation can be used to gather insights into the running system, but is completely optional.\n\n7. Deploy / Monitor your app as normal\n\nThe app that you've created is a normal Elixir app. This means that you can utilize your normal deployment / monitoring solutions without much additional ceremony. You can run your app locally by using:\n\n```bash\nmix run --no-halt\n```\n\nYou can read more about deployment in the [Deployment](/deployment.html) guide.\n\nIf you deploy your app as a cluster, it is important that the nodes are able to communicate with each other. If they cannot, then the PG2 system will not work and you will receive missed messages. You can read about different clustering solutions in the [Phoenix PubSub](/pub_sub.html) guide.","ref":"standalone.html#instructions"},{"type":"extras","title":"Authentication","doc":"# Authentication\n\nEnsuring that your PushEx installation is properly authenticated is crucial for security. Without proper authentication controls, an unintended party could connect to your system or send out pushes through your API.","ref":"authentication.html"},{"type":"extras","title":"Controllers - Authentication","doc":"`PushEx.Behaviour.Controller.auth/2` is the function that will be invoked to authenticate your API controller. The module that implements the Controller Behaviour will be set using Application config:\n\n```elixir\nconfig :push_ex, PushExWeb.PushController, controller_impl: DemoApp.Controller\n```\n\nThe simplest way to authenticate your controller is to return either `:ok` or `:error` atoms from your `auth/2` implementation. Your implementation should *always* have a case that must be met for `:ok` to be returned, or your system will not be secure.\n\nIt is recommended to never expose the authentication for your controller directly to your users, unless you add additional validation of the parameters for that user. Without full validation of the parameters, it would be possible for a user to send pushes for a channel that they don't have permission to access.","ref":"authentication.html#controllers"},{"type":"extras","title":"Socket / Channel - Authentication","doc":"The socket and channel authentication are a bit more complex than the controller authentication. This is because the controller authentication will commonly be system -> system while the socket authentication is inherently user based.\n\n`PushEx.Behaviour.Socket` includes `socket_connect/3` and `channel_join/3` callbacks in order to provide authentication for sockets and channels.","ref":"authentication.html#socket-channel"},{"type":"extras","title":"Socket vs Channel - Authentication","doc":"A user may be generally allowed to open a socket to the system (they aren't listening to messages, but have the ability to start) but may be denied from joining certain channels. An example of this is that \"user 1\" is logged in (has ability to open a socket) but cannot join \"user 2\"'s push channel. Two different authentication strategies must be provided based on this.\n\nYou can set your socket authentication implementation by using:\n\n```elixir\nconfig :push_ex, PushExWeb.PushSocket, socket_impl: DemoApp.Socket\n```","ref":"authentication.html#socket-vs-channel"},{"type":"extras","title":"Socket - Authentication","doc":"Socket authentication answers the question \"should this request be able to connect to websockets at all?\". Due to limitations in Phoenix Websocket implementation, it is not possible to use cookies when implementing socket authentication. Thus, it is very common to include a server signed token when connecting to a socket.\n\nIn PushEx.js, this would be done by implementing `getParams` with a returned `token` parameter. I recommend JWT as the token parameter as it provides tamper-proof secrets that can be passed through the client without worry. It is important to not put secrets in the JWT, however, because JWT tokens can be inspected by anyone regardless of whether they have the key or not!\n\nYour socket authentication will return either `{:ok, socket}` or `:error` based on the result of your authentication check. It is possible to include values in the socket using `Phoenix.Socket.assign/3`. In my systems, I will commonly take the contents of the JWT tokens (which include user ID) and `assign` that into a variable such as `user_id`. You will see why this is useful in the channel authentication.","ref":"authentication.html#socket"},{"type":"extras","title":"Channel - Authentication","doc":"Channel authentication answers the question \"should this connected socket be able to connect to this specific topic?\". An example of this is a socket opened by \"user 1\" joining the channel `private-user-1`. You might answer this question \"yes\" because the user's ID and the channel user ID match. However, you may answer \"no\" to whether \"user 1\" can join `private-user-10` because the IDs do not match.\n\nThe first argument of `channel_join` is the string containing the channel topic that is being joined. This topic is what you push to, and will often contain a piece of identifying information such as user ID. There are exceptions to this rule, however, such as an app-wide channel that all users can connect to.\n\nYour channel authentication should return either `{:ok, socket}` or `:error` based on the result of your authentication check. In my systems, I will commonly take the assigned socket content such as `user_id` and verify that the channel topic string matches this value. In doing this, I must ensure that the socket contains all information that would be needed to identify all topics that I might connect to.","ref":"authentication.html#channel"},{"type":"extras","title":"General Recommendations - Authentication","doc":"I have found that JSON Web Tokens (JWTs) are the easiest way to pass information from the frontend to the backend for authentication purposes and I highly recommend looking at them as part of your authentication strategy. If you go down this route, consider what would happen if your PushEx server rebooted (like during a deploy): if all of your connected users had to refetch a token from your server, would that amount of load be acceptable? My answer to this question is to fetch a short lived JWT every 10 minutes, just in case it's needed.\n\nWrite ExUnit tests for all of your authentication functions. Even if you write no other tests, it is very important to have your security code covered by tests.\n\nDo not write authentication functions that return \"ok\" results without verifying that they are indeed okay. This would open your system for exploitation. This is equivalent to writing a login function that always returns true.","ref":"authentication.html#general-recommendations"},{"type":"extras","title":"Custom Plug Setup","doc":"# Custom Plug Setup\n\nIt is possible to configure the web API to use custom plug setups. This can be useful if you are using a module such as `Plugsnag` or `NewRelic` which requires inserting code like `use Plugsnag` into your router. This can also be useful if you want to expose custom HTTP endpoints on the same port that PushEx runs, such as a health check.\n\nHere is an example of how to do this:\n\n```elixir\n# config.exs\n\nadditional_setup = quote do\n  use Plugsnag\nend\n\nconfig :push_ex, PushExWeb.Router,\n  additional_setup: additional_setup,\n  config_path: __ENV__.file\n```\n\nYou can see that the additional setup uses a quoted block in order to include the custom code. This code will then be injected into the PushExWeb.Router at compile time.\n\nDue to this needing to happen at compile time, you must use a quoted block and not a module in your application's lib. Your app is compiled after all dependencies, but PushEx dependency would need access to a module in your app. This would cause an incorrect ordering and you would encounter a module not defined error. This also means that you would not be able to `use MyApp.CustomPlug` because `MyApp` isn't available during PushEx compilation. However, you are capable of writing controllers in your application similar to how `examples/test_frontend_socket` does with `Controller.Status`.\n\nYou must path `config_path` for the additional plug setup to be compiled. This is due to needing to utilize `@external_resource` on your config file to cause PushEx to recompile on config.exs changes.","ref":"custom_plugs.html"},{"type":"extras","title":"Deployment","doc":"# Deployment\n\nCongrats on making it this far, you're ready to deploy! This is one of the final steps and the start of having a great push server at your disposal, but make sure to not cut any corners here.\n\nPushEx can be deployed like any other Elixir application. If you have experience deploying an Elixir application, then you should most likely follow what you're familiar with. If you have no experience deploying an Elixir application, then I'm hoping to help you out here with some general recommendations!\n\nThis guide will not go from A->B of shipping a server, but will give you some pointers on how to go about it. There are a lot of tutorials out there on shipping Elixir applications, and there should be no difference between this and other deployments.","ref":"deployment.html"},{"type":"extras","title":"Shipping \"Releases\" - Deployment","doc":"It is highly recommended in the Elixir community to use [Distillery](https://github.com/bitwalker/distillery) to build and ship releases of your application. These releases give you some benefits such as:\n\n* No source code necessary on the deployment\n* `remote_console` command to connect to running nodes easily\n* Faster boot because the application is already compiled\n\nIt is recommended to use Distillery for PushEx for these reasons. It is not necessary, but again is highly recommended.","ref":"deployment.html#shipping-releases"},{"type":"extras","title":"On Heroku - Deployment","doc":"Phoenix has an excellent [Heroku Guide](https://hexdocs.pm/phoenix/heroku.html) which walks through releasing an application on Heroku. Most of the changes are at the config.exs level (which you provide fully) and the 45s websocket timeout accommodation has been added by default to PushEx.\n\nYou should be very careful about [Heroku's connection limits](http://veldstra.org/2013/10/25/heroku-websocket-performance-test.html) as they could spell disaster for a server like PushEx. This is because websocket connections can only be made at a rate of ~150 conn/s and a single server can only have ~6000 conns. If you had 6000 connections on 1 server and it rebooted while all connections were active, it would take over 40s to reconnect everyone!","ref":"deployment.html#on-heroku"},{"type":"extras","title":"PubSub - Deployment","doc":"Please follow the [PubSub guide](https://hexdocs.pm/push_ex/pub_sub.html) in order to configure PubSub for your deployment. Note that you must use the Redis adapter for PubSub if deploying to Heroku.","ref":"deployment.html#pubsub"},{"type":"extras","title":"Taking a Node Offline - Deployment","doc":"You may or may not be taking Nodes offline for deployments. I am doing so with Kubernetes and Heroku also requires\nrestarting for deployments. PushEx tries to handle a lot of this for you by providing exit listeners for the web\nserver and for the Push.ItemProducer data pipeline. Each item is given 10 seconds to complete (20s) total. This\nshould minimize the likelihood of a process being offline but connections still trying to use the process.\n\nSockets can be disconnected when the server is brought offline. This is *not* performed by default as it\ncould be the wrong thing to do in certain environments. It is easy to turn on this option with a configuration:\n\n```elixir\nconfig :push_ex, PushExWeb.PushSocket,\n  socket_impl: TestFrontendSocket,\n  disconnect_sockets_on_shutdown: true\n```\n\nLocal socket transports will be sent a disconnect broadcast. The client will automatically start reconnecting\nto establish the connection. It is important that your load balancer does not send any new connections to the\nold node or they will fail because the web server will not accept new connections.","ref":"deployment.html#taking-a-node-offline"},{"type":"extras","title":"Recommendations - Deployment","doc":"Every company will be different with regards to how they deploy application: docker, amazon, google, heroku, kubernetes, the list goes on. Therefore, it's impossible to make a direct recommendation of what you should do when deploying PushEx. However, I can caution that Heroku will most likely be a bad choice for large applications and instead you should consider other routes.\n\nThere will likely be deployment templates over time as the community requests it and the need arises. Please reach out in an issue if you have any questions about deployment.","ref":"deployment.html#recommendations"},{"type":"extras","title":"Instrumentation","doc":"# Instrumentation\n\nSeveral hooks are provided to gather information about the execution of your PushEx server. These are provided by `PushEx.Behaviour.PushInstrumentation` and are configured by using:\n\n```elixir\n# Note that you can set multiple listeners by including multiple in the list.\nconfig :push_ex, PushEx.Instrumentation, push_listeners: [DemoApp.PushInstrumenter]\n```\n\nBe careful with how you are handling your push logging. There could be sensitive information in the payload, and the payload could be quite large. If logging out every push / API call to disk or another logging service, it would be very easy to send a large amount of bytes very quickly.","ref":"instrumentation.html"},{"type":"extras","title":"Context - Instrumentation","doc":"Each instrumentation includes a `PushEx.Instrumentation.Push.Context` argument which provides information such as when the event originated. Events are processed synchronously, which means that the service could slow down if your instrumentation is expensive. You could manually switch to asynchronous in this case, although I have been bit by this approach.","ref":"instrumentation.html#context"},{"type":"extras","title":"HTTP API - Instrumentation","doc":"The instrumentation behaviour provides `api_requested/1` and `api_processed/1`. This allows you to know each time that an API call is invoked and when it finishes.\n\nThe `%Plug.Conn{}` and `params` map are currently *not* passed into this analytics function, because it could become very expensive to maintain the binaries longer than necessary. If you desire to log specific information at the controller level, you could do so in your authentication function, which receives the `%Plug.Conn{}` and `params`.","ref":"instrumentation.html#http-api"},{"type":"extras","title":"Push Delivery - Instrumentation","doc":"The instrumentation behaviour provides `requested/2` and `delivered/2`. `requested` is invoked with the `PushEx.Push` contents when a Push originates in the system. `delivered` is invoked with the `PushEx.Push` contents when a Push is delivered to a channel.\n\nIt is expected that requested/delivered could vary wildly from system to system. For example, it is possible to have 0 connected users but be sending pushes into the system (because your other systems don't know about who is connected). This would lead to a `requested` rate of N but a `delivered` rate of 0. Another example is that your `requested` rate is N but your `delivered` rate is N*10 because every push goes to 10 different connected channels.","ref":"instrumentation.html#push-delivery"},{"type":"extras","title":"Why? - Instrumentation","doc":"Instrumenting your system is critical for understanding how it is being used. I personally recommend sending as much information as possible to a StatsD aggregator like DataDog in order to create charts of what the requested vs delivered rate is, or what the throughput of your API is.","ref":"instrumentation.html#why"},{"type":"extras","title":"Pushex.js","doc":"# Pushex.js\n\nPushex.js is the JavaScript client library for PushEx. The [Github Repo](https://github.com/pushex-project/pushex.js) contains full documentation.","ref":"js.html"},{"type":"extras","title":"Phoenix PubSub","doc":"# Phoenix PubSub\n\n[Phoenix PubSub](https://hexdocs.pm/phoenix_pubsub/Phoenix.PubSub.html) is a critical element of shipping production ready push servers, due to how persistent socket connections work.\n\nLet's consider that there are 2 servers in production behind a load balancer and that any request can go to either of the servers. This means that \"user 1\" could connect to \"server 1\" and open a persistent websocket connection. \"server 1\" knows about this connection because it's local to it, but \"server 2\" has no knowledge of it. Our push API request comes in to \"server 2\" and needs delivered to \"server 1\". There is an inherent disconnection of information here and the two servers need bridged in order to communicate. Enter PubSub.\n\nPubSub works by broadcasting messages between all servers in the cluster. These messages include presence information (who is connected to the system) as well as push data (send push X out). Phoenix PubSub works in a mesh network, so a server will broadcast the same message to all connected servers. This means that if you send a 10 KB push notification out and have 5 total servers, your server that receives it will send 10 KB of data to 4 other servers (40 KB total). It is important to understand how this spread works if you are experiencing large load.","ref":"pub_sub.html"},{"type":"extras","title":"PubSub Options - Phoenix PubSub","doc":"PubSub provides 2 different options and your selection of the correct one is important:\n\n* Phoenix.PubSub.PG2\n* Phoenix.PubSub.Redis\n\nPG2 uses erlang's internal message passing in order to deliver messages between nodes. Redis uses Redis's provided PubSub functionality to deliver messages.","ref":"pub_sub.html#pubsub-options"},{"type":"extras","title":"PG2 - Phoenix PubSub","doc":"PG2 is useful when you are able to connect your servers together using built in `Node.connect` functionality in Elixir. There are a variety of libraries to assist in doing this, such as:\n\n* [Peerage](https://github.com/mrluc/peerage)\n* [libcluster](https://github.com/bitwalker/libcluster)\n\nSetting this up is outside of the realm of this guide, but is advantageous over Redis if possible due to removing a single networking bottleneck.","ref":"pub_sub.html#pg2"},{"type":"extras","title":"Redis - Phoenix PubSub","doc":"Redis is useful at times when you are not able to setup communication between nodes, but can setup communication to a central redis server. A great example of this is Heroku, where it is impossible to network two erlang nodes together.\n\nSetting this up is outside of the realm of this guide, but is advantageous when you are not able to setup PG2. However, you will be left with a single networked point of failure (although Redis is very good when setup with enough capacity for your use case).","ref":"pub_sub.html#redis"},{"type":"extras","title":"Setup - Phoenix PubSub","doc":"The setup of PubSub in PushEx is done through your `config.exs` file. Since Phoenix 1.5 has been released, the PubSub is configured at the application level. You can set the config key for customization. For example, this will configure a PG2 adapter with a pool size of 4.\n\n```elixir\nconfig :push_ex, PushEx.PubSub,\n  adapter: Phoenix.PubSub.PG2,\n  pool_size: 4\n```\n\nPlease note that pool_size is set in the above config. I recommend setting this to the number of CPUs of your server size. Doing so helps remove a performance bottle neck that occurs at very high usage.\n\nYou can setup `PubSub.Redis` by following the [module's documentation](https://github.com/phoenixframework/phoenix_pubsub_redis). You would set it up under the `config :push_ex, PushExWeb.PubSub` config. For example:\n\n```elixir\nconfig :push_ex, PushEx.PubSub,\n  adapter: Phoenix.PubSub.Redis,\n  host: \"192.168.1.100\",\n  node_name: System.get_env(\"NODE\")\n```","ref":"pub_sub.html#setup"},{"type":"extras","title":"Considerations - Phoenix PubSub","doc":"It is possible to avoid actually setting this up and using `PG2` without networking if you have a 1 node server. However, you should be really careful if you set up a production system like this, as you would have a single point of failure. It has been demonstrated through load tests that a single server can accept a very high load, but it will vary greatly on each implementation and use case.","ref":"pub_sub.html#considerations"},{"type":"extras","title":"HTTP Push API","doc":"# HTTP Push API\n\nPushEx exposes a very small interface to create pushes that are sent to connected clients. This interface is exposed automatically for you, and is protected through the `PushEx.Behaviour.Controller` implementation that is defined for your application.","ref":"push_api.html"},{"type":"extras","title":"Security - HTTP Push API","doc":"Do not ship an implementation of controller behaviour to production that does not have authentication or protection. This would put your system at risk of sending arbitrary data to your connected clients.","ref":"push_api.html#security"},{"type":"extras","title":"API Request - HTTP Push API","doc":"The route `POST /api/push` is exposed on your web server. For instance, the URL in examples/test_frontend_socket is `http://localhost:4004/api/push`.\n\nThe push controller accepts the following arguments:\n\n* `channel` - An array or single string containing the channels that the push will be delivered to.\n* `data` - The JSON compatible data that will be sent in the push.\n* `event` - The name of the event that will be pushed.\n\nThe controller will respond with a JSON response status 200 if successful, containing a sanitized version of the data delivered in the push. This allows you to debug if the push is not coming through correctly.\n\nIn the case of an error, such as missing fields, the server will return a JSON response 422 with an error message.\n\nIn the case of an invalid authentication, the server will return a JSON response 403 \"Access Forbidden\".","ref":"push_api.html#api-request"},{"type":"extras","title":"Example - HTTP Push API","doc":"Using the examples/test_frontend_socket application, the following JSON request/response is seen:\n\n```\ncurl -i -X POST \\\n    http://localhost:4004/api/push \\\n    -H 'content-type: application/json' \\\n    -d '{\n    \"channel\": [\"test\", \"test2\", \"test\"],\n    \"data\": \"data\",\n    \"event\": \"woohoo\"\n  }'\n\nHTTP/1.1 200 OK\ncache-control: max-age=0, private, must-revalidate\ncontent-length: 59\ncontent-type: application/json; charset=utf-8\ndate: Thu, 29 Nov 2018 05:26:04 GMT\nserver: Cowboy\nx-request-id: 2llo21pptuh5gla7cg0002v4\n\n{\"channel\":[\"test\",\"test2\"],\"data\":\"data\",\"event\":\"woohoo\"}\n```\n\nNotice that the channel was passed with test duplicated, but was returned with a single test channel. This is an example of how the response will be the real data that the server processed, and not a plain mirror of the input.","ref":"push_api.html#example"}],"content_type":"text/markdown","proglang":"elixir","producer":{"name":"ex_doc","version":"0.36.1"}}